#include <u.h>
#include <lib9c.h>
#include <stdio.h>

static void
_sysfatalimpl(char *fmt, va_list arg)
{
	char buf[1024], err[128], *perr;

	if (strstr(fmt, "%r") != nil) {		// Hack.
		p9errstr(err, sizeof err - 1);
		err[sizeof err - 1] = '\0';
		perr = err;
	}
	else 
		perr = nil;
	vsprintf(buf, fmt, arg);
	fprintf(stderr, "%s%s\n", buf, perr? perr: "");
	p9exits(buf);
}

void (*p9_sysfatal)(char *fmt, va_list arg) = _sysfatalimpl;

void
p9sysfatal(char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	(*p9_sysfatal)(fmt, arg);
	va_end(arg);
}
