#include <float.h>
#include <math.h>

#define	NANEXP	(2047<<20)
#define	NANMASK	(2047<<20)
#define	NANSIGN	(1<<31)

double
NaN(void)
{
	FPdbleword a;

	a.lohi.hi = NANEXP;
	a.lohi.lo = 1;
	return a.x;
}

int
isNaN(double d)
{
	FPdbleword a;

	a.x = d;
	if((a.lohi.hi & NANMASK) != NANEXP)
		return 0;
	return !isInf(d, 0);
}

double
Inf(int sign)
{
	FPdbleword a;

	a.lohi.hi = NANEXP;
	a.lohi.lo = 0;
	if(sign < 0)
		a.lohi.hi |= NANSIGN;
	return a.x;
}

int
isInf(double d, int sign)
{
	FPdbleword a;

	a.x = d;
	if(a.lohi.lo != 0)
		return 0;
	if(a.lohi.hi == NANEXP)
		return sign >= 0;
	if(a.lohi.hi == (NANEXP|NANSIGN))
		return sign <= 0;
	return 0;
}
